//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Pr12conv.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 OpenDialog1->FileName=Edit1->Text;
 if(OpenDialog1->Execute()){
    Edit1->Text=OpenDialog1->FileName;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
 OpenDialog2->FileName=Edit2->Text;
 if(OpenDialog2->Execute()){
    Edit2->Text=OpenDialog2->FileName;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
 int d=RadioGroup1->ItemIndex;
 if(d==-1) return ShowMessage(/*"Nincs irny kivlasztva!"*/texts->Values["nodir"]);
 int ki=ComboBox1->ItemIndex;
 if(ki==-1) return ShowMessage(/*"Nincs szintfajta kivlasztva!"*/texts->Values["nolev"]);
 int gk=ComboBox2->ItemIndex;
 if(gk==-1) return ShowMessage(/*"Nincs ellensgfajta kivlasztva!"*/texts->Values["nogua"]);
 int l1=UpDown1->Position,l2=UpDown2->Position,ln=UpDown3->Position;
 bool gp=CheckBox1->Checked;
 AnsiString f1=Edit1->Text,f2=Edit2->Text;
 convert(f1,f2,d,l1,l2,gp,ln,ki,gk);
}
//---------------------------------------------------------------------------
void TForm1::convert(AnsiString f1,AnsiString f2,int d,int l1,int l2,bool gp,int ln,int ki,int gk){
 int ks[]={2,3,4};
 int gs[]={0,2,5,7,255};
 int gf[]={77,112,130,77,0};
 unsigned __int32 sa;
 unsigned __int16 si,n;
 int i;
 Tpop1rec pop1rec; Tpop2idx pop2idx; Tpop2rec pop2rec;
 unsigned char cs,ch;
 TMemoryStream* ms_dat1;
 TMemoryStream* ms_dat2;
 TMemoryStream* ms_lev1;
 TMemoryStream* ms_lev2;
 Tpop1level pop1level; Tpop2level pop2level;
 //load1
 ms_dat1=new TMemoryStream;
 try{
    ms_dat1->LoadFromFile(f1);
 }catch(...){
    delete ms_dat1;
    return ShowMessage(/*"Nem tallom a fjlt! (1)"*/texts->Values["file1"]);
 }
 //---
 //---
 //load2
 ms_dat2=new TMemoryStream;
 try{
    ms_dat2->LoadFromFile(f2);
 }catch(...){
    delete ms_dat1; delete ms_dat2;
    return ShowMessage(/*"Nem tallom a fjlt! (2)"*/texts->Values["file2"]);
 }
 Eleje:
 ln--;
 //---
 //find1
 ms_dat1->Seek(0,soFromBeginning);
 ms_dat1->Read(&sa,4);
 ms_dat1->Read(&si,2);
 ms_dat1->Seek(sa,soFromBeginning);
 ms_dat1->Read(&n,2);
 for(i=0;i<n;i++){
    ms_dat1->Read(&pop1rec,8);
    if(pop1rec.id==2000+l1) goto Fnd1;
 }
 delete ms_dat1; return ShowMessage(/*"Nem tallom a szintet! (1)"*/texts->Values["level1"]);
 Fnd1:
 ms_lev1=new TMemoryStream;
 ms_dat1->Seek(pop1rec.sa,soFromBeginning);
 ms_dat1->Read(&cs,1);
 for(i=0;i<pop1rec.len;i++){
    ms_dat1->Read(&ch,1);
    ms_lev1->Write(&ch,1);
    cs+=ch;
 }
 if(cs!=255){
    delete ms_dat1; delete ms_dat2; delete ms_lev1;
    return ShowMessage(/*"rvnytelen checksum!"*/texts->Values["checksum1"]);
 }
 //---
 //find2
 ms_dat2->Seek(0,soFromBeginning);
 ms_dat2->Read(&sa,4);
 ms_dat2->Read(&si,2);
 ms_dat2->Seek(sa,soFromBeginning);
 ms_dat2->Read(&n,2);
 for(i=0;i<n;i++){
    ms_dat2->Read(&pop2idx,6);
    if(pop2idx.idx==0) goto Idx2;
 }
 delete ms_dat1; delete ms_lev1; delete ms_dat2;
 return ShowMessage(/*"Nem tallom az indexet! (2)"*/texts->Values["index2"]);
 Idx2:
 ms_dat2->Seek(sa+pop2idx.sa,soFromBeginning);
 ms_dat2->Read(&n,2);
 for(i=0;i<n;i++){
    ms_dat2->Read(&pop2rec,11);
    if(pop2rec.id==2000+(l2-1)+(gp?20:0)) goto Fnd2;
 }
 delete ms_dat1; delete ms_lev1; delete ms_dat2;
 Fnd2:
 ms_lev2=new TMemoryStream;
 ms_dat2->Seek(pop2rec.sa,soFromBeginning);
 ms_dat2->Read(&cs,1);
 for(i=0;i<pop2rec.len;i++){
    ms_dat2->Read(&ch,1);
    ms_lev2->Write(&ch,1);
    cs+=ch;
 }
 if(cs!=255){
    delete ms_dat1; delete ms_lev1; delete ms_dat2; delete ms_lev2;
    return ShowMessage(/*"rvnytelen checksum!"*/texts->Values["checksum2"]);
 }
// ShowMessage(IntToStr(l1)+","+IntToStr(l2));
 switch(d){
    case 0: // 1 -> 2
    unsigned char ti,m,m1,m2;
    int rm,s,o,egn,g1,g2,gr,gt,gn;
    ms_lev1->Seek(0,soFromBeginning);
    ms_lev1->Read(&pop1level,ms_lev1->Size);
    memset(&pop2level,0,sizeof(pop2level));
    for(rm=0;rm<24;rm++){
       for(s=0;s<3;s++){
          for(o=0;o<10;o++){
             ti=pop1level.tiles[rm][s][o]&0x1F;
             m=pop1level.backs[rm][s][o];
             m1=m2=0;
             switch(ti){
                case 0: case 1: case 3: case 8: case 9:
                case 0x0B: case 0x10: case 0x11: case 0x14: break;
                case 4:
                m1=((m==1)?200:0);
                break;
                case 2: case 5: case 0x0D: case 0x12:
                case 0x17: case 0x18: case 0x19: ti=1; break;
                case 7: ti=4; break;
                case 0x1A: case 0x1B: case 0x1C: case 0x1D: case 0x1F: ti=0; break;
                case 0x06: if(ki==1) ti=0x22; m1=m; break;
                case 0x0F: ti=(ki==1?0x22:5); m1=m; break;
                case 0x1E: ti=0x20; break;
                case 0x0C: ti=0x14; break;
                case 0x0A: m1=m<<5; break;
                case 0x13: if(ki==2) ti=1; break;
                case 0x0E: if(ki==2) m1=0x40; break;
                case 0x15: case 0x16: if(ki!=2) ti=1; break;
                default:
                //AnsiString st;
                //st.printf(texts->Values["whattodo"],ch);
                //ShowMessage("Nem tudom, mit kezdjek ezzel a darabbal: 0x"+IntToStr(ch));
                ch=0;
             }
             pop2level.tiles[rm][s][o]=ti;
             pop2level.backs[rm][s][o][0]=m1;
             pop2level.backs[rm][s][o][1]=m2;
             pop2level.backs[rm][s][o][2]=((ki==1)?0:9);
             pop2level.backs[rm][s][o][3]=((ki==2)?(o&1):0);
//             pop2level.wtf[rm][s][o]=0;
          }
       }

       for(i=0;i<4;i++){
          pop2level.links[rm][i]=pop1level.links[rm][i];
       }
//       pop2level.guards[rm].n=0;

       if(pop1level.guardpos[rm]<30&&gs[gk]!=255){
          pop2level.guards[rm].n=1;
          pop2level.guards[rm].guard[0].tile=pop1level.guardpos[rm];
          pop2level.guards[rm].guard[0].pos=144+(pop1level.guardpos[rm]%10)*32+16;
          pop2level.guards[rm].guard[0].index=0;
          pop2level.guards[rm].guard[0].dir=pop1level.guarddir[rm];
          pop2level.guards[rm].guard[0].frame=gf[gk];
          pop2level.guards[rm].guard[0].hp=3;
          pop2level.guards[rm].guard[0].kind=gs[gk];
          pop2level.guards[rm].guard[0].skill=pop1level.guardskill[rm];
          pop2level.guards[rm].guard[0].skel1=0;
          pop2level.guards[rm].guard[0].skel2=0;
          pop2level.guards[rm].guard[0].subkind=pop1level.guardcolor[rm];
       }
//       pop2level.comingguards[rm].n=0;
    }

    if(ki==1){
       for(rm=0;rm<24;rm++){
          for(s=0;s<3;s++){
             for(o=0;o<10;o++){
                if(pop2level.tiles[rm][s][o]==0x14){
                   if(o){
                      if(pop2level.tiles[rm][s][o-1]!=0x14) pop2level.backs[rm][s][o][0]=2;
                   }else{
                      int l=pop2level.links[rm][0];
                      if(l){
                         if(pop2level.tiles[l-1][s][9]!=0x14) pop2level.backs[rm][s][o][0]=2;
                      }
                   }
                }
                if(pop2level.tiles[rm][s][o]){
                   if(s<2){
                      if(pop2level.tiles[rm][s+1][o]!=0x14) pop2level.backs[rm][s][o][1]=1;
                   }else{
                      int l=pop2level.links[rm][3];
                      if(l){
                         if(pop2level.tiles[l-1][0][o]!=0x14) pop2level.backs[rm][s][o][1]=1;
                      }
                   }
                }
                if(pop2level.tiles[rm][s][o]==0x10&&s){
                   if(pop2level.tiles[rm][s-1][o]==0) pop2level.tiles[rm][s-1][o]=0x21;
                }
                if(pop2level.tiles[rm][s][o]==0x11&&s){
                   if(pop2level.tiles[rm][s-1][o]==0) pop2level.tiles[rm][s-1][o]=0x23;
                }
             }
          }
       }
    }

/*    for(rm=24;rm<32;rm++){
       for(s=0;s<3;s++){
          for(o=0;o<10;o++){
             pop2level.tiles[rm][s][o]=0;
             pop2level.backs[rm][s][o][0]=0;
             pop2level.backs[rm][s][o][1]=0;
             pop2level.backs[rm][s][o][2]=0;
             pop2level.backs[rm][s][o][3]=0;
             pop2level.wtf[rm][s][o]=0;
          }
       }
       for(i=0;i<4;i++){
          pop2level.links[rm][i]=0;
       }
    }*/
    pop2level.kind=ks[ki];
    pop2level.guardkind=gs[gk];
    pop2level.startroom=pop1level.startroom;
    pop2level.starttile=pop1level.starttile;
    pop2level.startdir=pop1level.startdir;
    pop2level.jeff='CONV';
/*    for(i=0;i<9;i++){
       pop2level.checkpoints[i].room=0;
       pop2level.checkpoints[i].tile=0;
    }*/
    egn=1;
    for(i=0;i<256;i++){
       g1=pop1level.gates1[i];
       g2=pop1level.gates2[i];
       gr=((g2>>5)<<2)+((g1>>5)&3);
       gt=g1&31;
       gn=g1>>7;
       if(pop2level.tiles[gr-1][0][gt]==0x10) gt++;
       pop2level.gates[i][0]=gr;
       pop2level.gates[i][1]=gt;
       pop2level.gates[i][2]=0;
       pop2level.gates[i][3]=(egn?0xFD:(i-1));
       pop2level.gates[i][4]=(gn?0xFD:(i+1));
       egn=gn;
    }
    pop2level.levelnum=0;
/*    pop2level.incomp[0]=1;
    pop2level.incomp[1]=0;
    pop2level.incomp[2]=0;
    pop2level.incomp[3]=1;
    pop2level.incomp[4]=0;
    pop2level.incomp[5]=1;
    pop2level.incomp[6]=1;
    pop2level.incomp[7]=0;*/
    pop2level.incomp[8]=1;
    pop2level.incomp[9]=1;
    pop2level.incomp[10]=1;
    pop2level.incomp[11]=1;
    pop2level.rmcount=32;
    pop2level.uk1=9;
    pop2level.uk2[0]=0;
    pop2level.uk2[1]=1;
    pop2level.uk2[2]=0;

    ms_lev2->Seek(0,soFromBeginning);
    ms_lev2->Write(&pop2level,ms_lev2->Size);
//    ms_lev2->SaveToFile("DUMP");
    cs=255;
    ms_lev2->Seek(0,soFromBeginning);
    ms_dat2->Seek(pop2rec.sa+1,soFromBeginning);
    for(i=0;i<ms_lev2->Size;i++){
       ms_lev2->Read(&ch,1);
       ms_dat2->Write(&ch,1);
       cs-=ch;
    }
    ms_dat2->Seek(pop2rec.sa,soFromBeginning);
    ms_dat2->Write(&cs,1);
    if(ln){
       l1++; l2++;
       delete ms_lev1; delete ms_lev2;
       goto Eleje;
    }
    ms_dat2->SaveToFile(f2);
    break;
    case 1: // 2 -> 1
    // Coming soon! - Hamarosan!
    ShowMessage(texts->Values["notimp"]);
    break;
 }

 delete ms_dat1; delete ms_lev1; delete ms_dat2; delete ms_lev2;
}
//---------------------------------------------------------------------------
void TForm1::setlang(){
#define open_s(a) s=(a);
#define read(a,b) a=mi->ReadString(s,(b),"");
   TMemIniFile* mi; AnsiString s;
   mi=new TMemIniFile(path+"texts\\"+lng_file);
   open_s("main");
   read(Form1->Caption,"title");
   read(Label1->Caption,"pop1level");
   read(Label2->Caption,"pop2level");
   read(Label3->Caption,"level");
   read(Label4->Caption,"level");
   read(Button1->Caption,"browse");
   read(Button2->Caption,"browse");
   read(RadioGroup1->Caption,"dir");
   read(RadioGroup1->Items->CommaText,"dirs");
   read(CheckBox1->Caption,"gameplay");
   read(Button3->Caption,"go");
   read(OpenDialog1->Filter,"pop1filt");
   read(OpenDialog1->Title,"openpop1");
   read(OpenDialog2->Filter,"pop2filt");
   read(OpenDialog2->Title,"openpop2");
   read(Label5->Caption,"leveln");
   read(ComboBox1->Items->CommaText,"levelk");
   read(ComboBox2->Items->CommaText,"guardk");

   mi->ReadSectionValues("texts",texts);
   delete mi;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 texts=new TStringList();
 path=ExtractFilePath(Application->ExeName);
 sl=new TStringList();
 sl->LoadFromFile(path+"texts\\Pr12conv.ini");
 lng_file=sl->Values["lang"];
 Form1->setlang();
 Edit1->Text=sl->Values["MRUpop1"];
 Edit2->Text=sl->Values["MRUpop2"];
 UpDown3Click(Sender,0);
 ComboBox1->ItemIndex=0;
 ComboBox2->ItemIndex=3;
 RadioGroup1->ItemIndex=0;
 if(ParamCount()>=9){
    AnsiString f1=ParamStr(1),f2=ParamStr(2);
    int d=StrToInt(ParamStr(3));
    int l1=StrToInt(ParamStr(4)),l2=StrToInt(ParamStr(5)),ln=StrToInt(ParamStr(7));
    bool gp=StrToInt(ParamStr(6));
    int ki=StrToInt(ParamStr(8));
    int gk=StrToInt(ParamStr(9));
    convert(f1,f2,d,l1,l2,gp,ln,ki,gk);
    Application->Terminate();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 sl->Values["MRUpop1"]=Edit1->Text;
 sl->Values["MRUpop2"]=Edit2->Text;
 sl->SaveToFile(path+"texts\\Pr12conv.ini");
 delete sl;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpDownClick(TObject *Sender, TUDBtnType Button)
{
 int v1=15-UpDown1->Position+1,v2=14-UpDown2->Position+1;
 int v=((v1<v2)?v1:v2);
 if(UpDown3->Position>v){
    UpDown3->Position=v;
 }
 UpDown3->Max=v;
 UpDown3Click(Sender,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpDown3Click(TObject *Sender, TUDBtnType Button)
{
 AnsiString s;
 int l1=UpDown1->Position,l2=UpDown2->Position,l=UpDown3->Position;
 s.printf("%d - %d -> %d - %d",l1,l1+l-1,l2,l2+l-1);
 Label6->Caption=s;
}
//---------------------------------------------------------------------------

